//////////////////////////////////////////////////////////////////////
// calc.js
//  CHANGELOG
//  2010.05.06 nextCondition()
//  2010.05.07 reCalc(), chooseCondition(), chooseCauseValue() 追加
//  2010.05.09 deduceValue() M/Iの扱いの変更
//  2010.08.21 capsuleNodes()
//	2011.02.12 chooseCauseValue(), chooseCauseValue2(), chooseCauseValue3()
//////////////////////////////////////////////////////////////////////

function zoomOff(no)
{
	var	i, j, k;
	var	len		= nodes.length;

	if( nodes[no].getZoom() != no ){
		return true;
	}

	// カプセル展開するので、show()
	jQuery.each(nodes, function(i, val){
		if( g_zoom == -1 ){
			// 通常時あるいはズームアウト時
			if( this.getZoom() == no ){
				$("#N" + i).show();
				this.setZoom(-1);
			}
		}
		else{
			// ズームイン
			if( this.getZoom() == -1 ){
				$("#N" + i).show();
			}
			else{
				this.setZoom(-1);
			}
		}
	});

	jQuery.each(constrs, function(i, val){
		if( g_zoom == -1 ){
			// 通常時あるいはズームアウト時
			if( this.getZoom() == no ){
				$("#C" + i).show();
				this.setZoom(-1);
			}
		}
		else{
			// ズームイン
			if( this.getZoom() == -1 ){
				$("#C" + i).show();
			}
			else{
				this.setZoom(-1);
			}
		}
	});

	return true;
}

function zoomOut(no)
{
	var	nlen	= nodes.length;
	var	clen	= constrs.length;
	var	nlist	= new Array(nlen);
	var	clist	= new Array(clen);
	var	i, j, k;

	// 原因ノードあるいは結果ノードはカプセル化不可
	if( nodes[no].getOp() == "" ){
		dispMESSAGE("原因ノードはカプセル化できません。", "#ff4500");
		return false;
	}
//	if( nodes[no].isEffect() ){
//		dispMESSAGE("結果ノードはカプセル化できません。", "#ff4500");
//		return false;
//	}
	if( nodes[no].getZoom() == no ){
		return true;
	}

	// nlist初期化
	for(i = 0; i < nlen; i++){
		nlist[i] = 0;
	}

	// clist初期化
	for(i = 0; i < clen; i++){
		clist[i] = 0;
	}

	// クリックしたノード配下を探索
	nodes[no].getCause(nlist);

	// カプセル化可能かどうかノードのチェック
	for(i = 0; i < nlen; i++){
		if( nlist[i] == 1 ){
			if( nodes[i].getZoom() != -1 ){
				dispMESSAGE("入れ子のカプセル化はできません。", "#ff4500");
				return false;
			}
			else{
				continue;
			}
		}
		if( i == no ){
			// カプセル化するノード自身
			continue;
		}

		// クリックしたノード配下以外のノードについて
		var	r	= nodes[i].getSeq().split(",");

		for(j = 0; j < nlen; j++){
			if( j == no ){
				continue;
			}

			if( r[j] == 1 && nlist[j] == 1 ){
				dispMESSAGE("カプセル化できません。", "#ff4500");
				return false;
			}
		}
	}

	// カプセル化可能かどうか制約のチェック
	for(i = 0; i < constrs.length; i++){
		if( constrs[i].getType() == "ONE"
			|| constrs[i].getType() == "EXCL"
			|| constrs[i].getType() == "INCL" ){
			var		r	= constrs[i].getSeq().split(",");

			var	iflag = false;
			var	oflag = false;
			for(j = 0; j < nlen; j++){
				if( r[j + 2*nlen] == 1 ){
					if( nlist[j] == 1 ){
						iflag = true;
					}
					else{
						oflag = true;
					}
				}
			}

			if( iflag == true && oflag == false ){
				clist[i] = 1;
			}
			else if( iflag == true && oflag == true ){
				dispMESSAGE("カプセル化できません。", "#ff4500");
				return false;
			}
		}
		else{
			var		r	= constrs[i].getSeq().split(",");

			var	iflag = false;
			var	oflag = false;
			for(j = 0; j < nlen; j++){
//				if( r[j] == 1 ){
//					if( nlist[j] == 1 ){
//						iflag = true;
//					}
//					else{
//						oflag = true;
//					}
//				}
				if( r[j + 2*nlen] == 1 ){
					if( nlist[j] == 1 ){
						iflag = true;
					}
					else{
						oflag = true;
					}
				}
			}

			if( iflag == true && oflag == false ){
				clist[i] = 1;
			}
			else if( iflag == true && oflag == true ){
				dispMESSAGE("カプセル化できません。", "#ff4500");
				return false;
			}
		}
	}

	// カプセル化したので、hide()
	nodes[no].setZoom(no);
	for(i = 0; i < nlen; i++){
		if( nlist[i] == 1 ){
			nodes[i].setZoom(no);
			$("#N" + i).hide();
		}
	}
	for(i = 0; i < clen; i++){
		if( clist[i] == 1 ){
			constrs[i].setZoom(no);
			$("#C" + i).hide();
		}
	}

	return true;
}

function zoomIn(no)
{
	var	nlen	= nodes.length;
	var	clen	= constrs.length;
	var	nlist	= new Array(nlen);
	var	clist	= new Array(clen);
	var	i, j, k;

	// 原因ノードあるいは結果ノードはズームイン不可
	if( nodes[no].getOp() == "" ){
		dispMESSAGE("原因ノードはズームインできません。", "#ff4500");
		return false;
	}
//	if( nodes[no].isEffect() ){
//		dispMESSAGE("結果ノードはズームインできません。", "#ff4500");
//		return false;
//	}
	if( nodes[no].getZoom() == no ){
		return true;
	}

	// nlist初期化
	for(i = 0; i < nlen; i++){
		nlist[i] = 0;
	}

	// clist初期化
	for(i = 0; i < clen; i++){
		clist[i] = 0;
	}

	// クリックしたノード配下を探索
	nodes[no].getCause(nlist);

	// カプセル化可能かどうかノードのチェック
	for(i = 0; i < nlen; i++){
//		if( nlist[i] == 1 || i == no ){
//			continue;
//		}
		if( nlist[i] == 1 ){
			if( nodes[i].getZoom() != -1 ){
				dispMESSAGE("入れ子のズームインはできません。", "#ff4500");
				return false;
			}
			else{
				continue;
			}
		}
		if( i == no ){
			// ズームインするノード自身
			continue;
		}

		// クリックしたノード配下以外のノードについて
		var	r	= nodes[i].getSeq().split(",");

		for(j = 0; j < nlen; j++){
			if( j == no ){
				continue;
			}

			if( r[j] == 1 && nlist[j] == 1 ){
				dispMESSAGE("ズームインできません。", "#ff4500");
				return false;
			}
		}
	}

	// ズームイン可能かどうか制約のチェック
	for(i = 0; i < constrs.length; i++){
		if( constrs[i].getType() == "ONE"
			|| constrs[i].getType() == "EXCL"
			|| constrs[i].getType() == "INCL" ){
			var		r	= constrs[i].getSeq().split(",");

			var	iflag = false;
			var	oflag = false;
			for(j = 0; j < nlen; j++){
				if( r[j + 2*nlen] == 1 ){
					if( nlist[j] == 1 ){
						iflag = true;
					}
					else{
						oflag = true;
					}
				}
			}

			if( iflag == true && oflag == false ){
				clist[i] = 1;
			}
			else if( iflag == true && oflag == true ){
				dispMESSAGE("ズームインできません。", "#ff4500");
				return false;
			}
		}
		else{
			var		r	= constrs[i].getSeq().split(",");

			var	iflag = false;
			var	oflag = false;
			for(j = 0; j < nlen; j++){
//				if( r[j] == 1 ){
//					if( nlist[j] == 1 ){
//						iflag = true;
//					}
//					else{
//						oflag = true;
//					}
//				}
				if( r[j + 2*nlen] == 1 ){
					if( nlist[j] == 1 ){
						iflag = true;
					}
					else{
						oflag = true;
					}
				}
			}

			if( iflag == true && oflag == false ){
				clist[i] = 1;
			}
			else if( iflag == true && oflag == true ){
				dispMESSAGE("ズームインできません。", "#ff4500");
				return false;
			}
		}
	}

	// ズームインしたので、それ以外をhide()
	nodes[no].setZoom(no);
	for(i = 0; i < nlen; i++){
		if( nlist[i] == 1 ){
			if( nodes[i].getZoom() == -1 ){
				nodes[i].setZoom(no);
			}
		}
		else{
			if( i != no ){
				$("#N" + i).hide();
			}
		}
	}
	for(i = 0; i < clen; i++){
		if( clist[i] == 1 ){
			constrs[i].setZoom(no);
		}
		else{
			$("#C" + i).hide();
		}
	}

	return true;
}

function deduce(src)
{
	var		i		= 0;
	var		len		= nodes.length;
	var		reason	= "";

	for(i = 0; i < len; i++){
		if( src[i] != "" ){
			continue;
		}

		// 左側の演繹計算
		deduceValue(src, i);
// 2011/02/12	演繹計算を左側から実施するため subs[i] 番目で呼び出す
// 一旦保留
//		deduceValue(src, subs[i]);

	}

	return "";
}

// 2010/08/21 カプセル化
function deduce2(src, zoom)
{
	var		i		= 0;
	var		len		= nodes.length;
	var		reason	= "";

	for(i = 0; i < len; i++){
		if( !(nodes[i].getZoom() == zoom || nodes[i].getZoom() == i) ){
			continue;
		}
		if( src[i] != "" ){
			continue;
		}

		// 左側の演繹計算
		deduceValue2(src, i, zoom);
	}

	return "";
}

// 2010/08/22 カプセル化
function deduce3(src, zoom)
{
	var		i		= 0;
	var		len		= nodes.length;
	var		reason	= "";

	for(i = 0; i < len; i++){
		if( !(nodes[i].getZoom() == zoom || nodes[i].getZoom() == i) ){
			continue;
		}
		if( src[i] != "" ){
			continue;
		}

		// 左側の演繹計算
		deduceValue3(src, i, zoom);
	}

	return "";
}

function deduceEffect(src, no)
{
	var		i;
	var		len		= nodes.length;

	jQuery.each(nodes, function(i, val){
		var		op		= this.getOp();
		var		seq		= this.getSeq();
		var		r		= seq.split(",");

		if( i != no && r[no] == 1 && src[i] == "" ){
			if( op == "AND" ){
				if( r[len + no] == 1 ){
					// NOT
					if( src[no] == "T" || src[no] == "t" ){
						src[i] = "F";
					}
				}
				else{
					if( src[no] == "F" || src[no] == "f" ){
						src[i] = "F";
					}
				}
			}
			else if( op == "OR" ){
				if( r[len + no] == 1 ){
					// NOT
					if( src[no] == "F" || src[no] == "f" ){
						src[i] = "T";
					}
				}
				else{
					if( src[no] == "T" || src[no] == "t" ){
						src[i] = "T";
					}
				}
			}
		}
	});

	return true;
}

function deduceValue(src, no)
{
	var		i		= 0;
	var		j		= 0;
	var		len		= nodes.length;
	var		v		= null;
	var		isUpdate	= false;
	var		isImpossible	= false;

	if( nodes[no].getOp() != "" && nodes[no].getSeq() == "" ){
		return true;
	}

	v = (nodes[no].getSeq()).split(",");

	if( nodes[no].getOp() == "AND" ){
		isUpdate	= false;
		isImpossible	= false;

		for(i = 0; i < len; i++){
			if( v[i] != 1 ){
				continue;
			}

			if( v[len + i] == 1 ){
				// NOT
				if( src[i] == "" ){
					deduceValue(src, i);
				}

				switch(src[i]){
				case 'F': case 'f':
					break;
				case 'T': case 't':
					src[no] = 'f';
					isUpdate = true;
					break;
				case 'M': case 'I':
//					src[no] = 'I';//一応
//					isUpdate = true;
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
			else{
				if( src[i] == "" ){
					deduceValue(src, i);
				}

				switch(src[i]){
				case 'T': case 't':
					break;
				case 'F': case 'f':
					src[no] = 'f';
					isUpdate = true;
					break;
				case 'M': case 'I':
//					src[no] = 'I';//一応
//					isUpdate = true;
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
		}

		if( isImpossible == true ){
			src[no] = "I";
		}
		else{
			src[no] = "t";
		}

		return true;
	}
	else if( nodes[no].getOp() == "OR" ){
		isUpdate	= false;
		isImpossible	= false;

		for(i = 0; i < len; i++){
			if( v[i] != 1 ){
				continue;
			}

			if( v[len + i] == 1 ){
				// NOT
				if( src[i] == "" ){
					deduceValue(src, i);
				}

				switch(src[i]){
				case 'F': case 'f':
					src[no] = "t";
					isUpdate = true;
					break;
				case 'T': case 't':
					break;
				case 'M': case 'I':
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
			else{
				if( src[i] == "" ){
					deduceValue(src, i);
				}

				switch(src[i]){
				case 'T': case 't':
					src[no] = "t";
					isUpdate = true;
					break;
				case 'F': case 'f':
					break;
				case 'M': case 'I':
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
		}

		if( isImpossible == true ){
			src[no] = "I";
		}
		else{
			src[no] = "f";
		}

		return true;
	}
}

// 2010/08/21 カプセル化
function deduceValue2(src, no, zoom)
{
	var		i		= 0;
	var		j		= 0;
	var		len		= nodes.length;
	var		v		= null;
	var		isUpdate	= false;
	var		isImpossible	= false;

	if( !(nodes[no].getZoom() == zoom || nodes[no].getZoom() == no) ){
		return true;
	}

	if( nodes[no].getOp() != "" && nodes[no].getSeq() == "" ){
		return true;
	}

	v = (nodes[no].getSeq()).split(",");

	if( nodes[no].getOp() == "AND" ){
		isUpdate	= false;
		isImpossible	= false;

		for(i = 0; i < len; i++){
			if( v[i] != 1 ){
				continue;
			}

			if( v[len + i] == 1 ){
				// NOT
				if( src[i] == "" ){
					deduceValue2(src, i, zoom);
				}

				switch(src[i]){
				case 'F': case 'f':
					break;
				case 'T': case 't':
					src[no] = 'f';
					isUpdate = true;
					break;
				case 'M': case 'I':
//					src[no] = 'I';//一応
//					isUpdate = true;
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
			else{
				if( src[i] == "" ){
					deduceValue2(src, i, zoom);
				}

				switch(src[i]){
				case 'T': case 't':
					break;
				case 'F': case 'f':
					src[no] = 'f';
					isUpdate = true;
					break;
				case 'M': case 'I':
//					src[no] = 'I';//一応
//					isUpdate = true;
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
		}

		if( isImpossible == true ){
			src[no] = "I";
		}
		else{
			src[no] = "t";
		}

		return true;
	}
	else if( nodes[no].getOp() == "OR" ){
		isUpdate	= false;
		isImpossible	= false;

		for(i = 0; i < len; i++){
			if( v[i] != 1 ){
				continue;
			}

			if( v[len + i] == 1 ){
				// NOT
				if( src[i] == "" ){
					deduceValue2(src, i, zoom);
				}

				switch(src[i]){
				case 'F': case 'f':
					src[no] = "t";
					isUpdate = true;
					break;
				case 'T': case 't':
					break;
				case 'M': case 'I':
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
			else{
				if( src[i] == "" ){
					deduceValue2(src, i, zoom);
				}

				switch(src[i]){
				case 'T': case 't':
					src[no] = "t";
					isUpdate = true;
					break;
				case 'F': case 'f':
					break;
				case 'M': case 'I':
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
		}

		if( isImpossible == true ){
			src[no] = "I";
		}
		else{
			src[no] = "f";
		}

		return true;
	}
}

// 2010/08/22 カプセル化その2
function deduceValue3(src, no, zoom)
{
	var		i		= 0;
	var		j		= 0;
	var		len		= nodes.length;
	var		v		= null;
	var		isUpdate	= false;
	var		isImpossible	= false;
	var		ntype	= nodes[no].getNodeType(zoom, no);

	if( ntype == 0 || ntype == -1 ){
		return true;
	}

	v = (nodes[no].getSeq()).split(",");

	if( nodes[no].getOp() == "AND" ){
		isUpdate	= false;
		isImpossible	= false;

		for(i = 0; i < len; i++){
			if( v[i] != 1 ){
				continue;
			}

			if( v[len + i] == 1 ){
				// NOT
				if( src[i] == "" ){
					deduceValue3(src, i, zoom);
				}

				switch(src[i]){
				case 'F': case 'f':
					break;
				case 'T': case 't':
					src[no] = 'f';
					isUpdate = true;
					break;
				case 'M': case 'I':
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
			else{
				if( src[i] == "" ){
					deduceValue3(src, i, zoom);
				}

				switch(src[i]){
				case 'T': case 't':
					break;
				case 'F': case 'f':
					src[no] = 'f';
					isUpdate = true;
					break;
				case 'M': case 'I':
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
		}

		if( isImpossible == true ){
			src[no] = "I";
		}
		else{
			src[no] = "t";
		}

		return true;
	}
	else if( nodes[no].getOp() == "OR" ){
		isUpdate	= false;
		isImpossible	= false;

		for(i = 0; i < len; i++){
			if( v[i] != 1 ){
				continue;
			}

			if( v[len + i] == 1 ){
				// NOT
				if( src[i] == "" ){
					deduceValue3(src, i, zoom);
				}

				switch(src[i]){
				case 'F': case 'f':
					src[no] = "t";
					isUpdate = true;
					break;
				case 'T': case 't':
					break;
				case 'M': case 'I':
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
			else{
				if( src[i] == "" ){
					deduceValue3(src, i, zoom);
				}

				switch(src[i]){
				case 'T': case 't':
					src[no] = "t";
					isUpdate = true;
					break;
				case 'F': case 'f':
					break;
				case 'M': case 'I':
					isImpossible = true;
					break;
				default:
					break;
				}
				if( isUpdate == true ){
					return true;
				}
			}
		}

		if( isImpossible == true ){
			src[no] = "I";
		}
		else{
			src[no] = "f";
		}

		return true;
	}
}

function reCalc(src, lnum)
{
	var		i, j, k, l;
	var		len		= nodes.length;

	for(i = 0; i < len; i++){
		src[i] = "";
	}

	for(i = 0; i < turns.length; i++){
		if( turns[i] < lnum ){
			// 論理展開式について
			for(j = 0; j < len; j++){
				if( logics[turns[i]][j] != "" ){
					src[j] = logics[turns[i]][j];
				}
			}
		}
		else{
			// 原因ノード
			var		no	= turns[i] - lnum;

			if( no % 2 == 0 ){
				src[no / 2] = "T";
			}
			else{
				src[(no - 1) / 2] = "F";
			}
		}
	}

	return true;
}

//
// 適切な論理式を選択し、配列baseへマージ
//   mode: 0	未選択の論理式を選択
//         1	既選択の論理式を選択
//
function chooseCondition(base, mode)
{
	var		i, j, k, l;
	var		len		= nodes.length;
	var		lnum	= 0;
	var		work	= new Array(len);
	var		tmp		= new Array(len);
	var		ret		= 0;

	for(i = 0; i < len; i++){
		work[i]	= base[i];
		tmp[i]	= base[i];
	}

	l		= 0;
	lnum	= 0;
	for(i = 0; i < len; i++){
		lnum = nodes[i].getLnum();
		if( lnum == 0 ){
			continue;
		}

		for(j = 0; j < lnum; j++, l++){
			// まだ網羅されていない論理式か否か
			if( mode == 0 && countCoverage(l) > 0 ){
				continue;
			}
			// 今回のテスト条件を生成する上で網羅されていない論理式か否か
			if( vtestcov[l] > 0 ){
				continue;
			}
			// 不適切な論理式か否か
			if( unsuitables[l] > 0 ){
				continue;
			}
			// 制約によりテスト不可能か否か
			if( infeasibles[l] != "" ){
				continue;
			}

			// 配列値をマージ可能か否か
			match = true;
			for(k = 0; k < len; k++){
				if( work[k] != "" && logics[l][k] != ""
					&& work[k] != logics[l][k] ){
					match = false;
					break;
				}
			}
			if( match == false ){
				continue;
			}

			// tmpへ配列値をマージ
			for(k = 0; k < len; k++){
				tmp[k] = work[k];
			}
			for(k = 0; k < len; k++){
				if( logics[l][k] != "" ){
					tmp[k] = logics[l][k];
				}
			}

			// 制約による演繹的な計算・検算
			match = true;
			for(k = 0; k < constrs.length; k++){
				if( constrs[k].deduceLogic(tmp) == false ){
					match = false;
					break;
				}
			}
			if( match == false ){
				continue;
			}

			// 制約不整合の検算
			reason = checkConstr(tmp);
			if( reason != "" ){
				if( turns.length == 0 ){
					// 一つ目の仮採用で不採用
					infeasibles[l] = reason;
				}
				continue;
			}

			// 論理関係不整合の検算
			reason = isPossible(tmp);
			if( reason != "" ){
				if( turns.length == 0 ){
					// 一つ目の仮採用で不採用
					infeasibles[l] = reason;
				}
				continue;
			}

			// workへ反映
			for(k = 0; k < len; k++){
				work[k] = tmp[k];
			}
calcmsg += "　【論理式" + (l + 1) + "】(mode=" + mode + ")\n" + dispLOGIC(work) + "\n";

			// 今回のテスト条件を生成する上で網羅
			vtestcov[l] = 1;
			// 採用した論理式番号
			turns[turns.length] = l;
			ret++;
		}
	}

	for(i = 0; i < len; i++){
		base[i] = work[i];
	}

	return ret;
}

// 2010/08/21 カプセル化
function chooseCondition2(base, mode, zoom)
{
	var		i, j, k, l;
	var		len		= nodes.length;
	var		lnum	= 0;
	var		work	= new Array(len);
	var		tmp		= new Array(len);
	var		ret		= 0;

	for(i = 0; i < len; i++){
		work[i]	= base[i];
		tmp[i]	= base[i];
	}

	l		= 0;
	lnum	= 0;
	for(i = 0; i < len; i++){
		lnum = nodes[i].getLnum();
		if( lnum == 0 ){
			continue;
		}

		for(j = 0; j < lnum; j++, l++){
			if( !(nodes[i].getZoom() == zoom) ){
				continue;
			}

			// まだ網羅されていない論理式か否か
			if( mode == 0 && countCoverage(l) > 0 ){
				continue;
			}
			// 今回のテスト条件を生成する上で網羅されていない論理式か否か
			if( vtestcov[l] > 0 ){
				continue;
			}
			// 不適切な論理式か否か
			if( unsuitables[l] > 0 ){
				continue;
			}
			// 制約によりテスト不可能か否か
			if( infeasibles[l] != "" ){
				continue;
			}

			// 配列値をマージ可能か否か
			match = true;
			for(k = 0; k < len; k++){
				if( work[k] != "" && logics[l][k] != ""
					&& work[k] != logics[l][k] ){
					match = false;
					break;
				}
			}
			if( match == false ){
				continue;
			}

			// tmpへ配列値をマージ
			for(k = 0; k < len; k++){
				tmp[k] = work[k];
			}
			for(k = 0; k < len; k++){
				if( logics[l][k] != "" ){
					tmp[k] = logics[l][k];
				}
			}

			// 制約による演繹的な計算・検算
			match = true;
			for(k = 0; k < constrs.length; k++){
				if( constrs[k].getZoom() == zoom ){
					if( constrs[k].deduceLogic(tmp) == false ){
						match = false;
						break;
					}
				}
			}
			if( match == false ){
				continue;
			}

			// 制約不整合の検算
			reason = checkConstr(tmp);
			if( reason != "" ){
				if( turns.length == 0 ){
					// 一つ目の仮採用で不採用
					infeasibles[l] = reason;
				}
				continue;
			}

			// 論理関係不整合の検算
			reason = isPossible(tmp);
			if( reason != "" ){
				if( turns.length == 0 ){
					// 一つ目の仮採用で不採用
					infeasibles[l] = reason;
				}
				continue;
			}

			// workへ反映
			for(k = 0; k < len; k++){
				work[k] = tmp[k];
			}
calcmsg += "　【論理式" + (l + 1) + "】(mode=" + mode + ")\n" + dispLOGIC(work) + "\n";

			// 今回のテスト条件を生成する上で網羅
			vtestcov[l] = 1;
			// 採用した論理式番号
			turns[turns.length] = l;
			ret++;
		}
	}

	for(i = 0; i < len; i++){
		base[i] = work[i];
	}

	return ret;
}

// 2010/08/22 カプセル化その2
function chooseCondition3(base, mode, zoom)
{
	var		i, j, k, l;
	var		len		= nodes.length;
	var		lnum	= 0;
	var		work	= new Array(len);
	var		tmp		= new Array(len);
	var		ret		= 0;

	for(i = 0; i < len; i++){
		work[i]	= base[i];
		tmp[i]	= base[i];
	}

	l		= 0;
	lnum	= 0;
	for(i = 0; i < len; i++){
		lnum = nodes[i].getLnum();
		if( lnum == 0 ){
			continue;
		}

		for(j = 0; j < lnum; j++, l++){
			// まだ網羅されていない論理式か否か
			if( mode == 0 && countCoverage(l) > 0 ){
				continue;
			}
			// 今回のテスト条件を生成する上で網羅されていない論理式か否か
			if( vtestcov[l] > 0 ){
				continue;
			}
			// 不適切な論理式か否か
			if( unsuitables[l] > 0 ){
				continue;
			}
			// 制約によりテスト不可能か否か
			if( infeasibles[l] != "" ){
				continue;
			}

			// 配列値をマージ可能か否か
			match = true;
			for(k = 0; k < len; k++){
				if( work[k] != "" && logics[l][k] != ""
					&& work[k] != logics[l][k] ){
					match = false;
					break;
				}
			}
			if( match == false ){
				continue;
			}

			// tmpへ配列値をマージ
			for(k = 0; k < len; k++){
				tmp[k] = work[k];
			}
			for(k = 0; k < len; k++){
				if( logics[l][k] != "" ){
					tmp[k] = logics[l][k];
				}
			}

			// 制約による演繹的な計算・検算
			match = true;
			for(k = 0; k < constrs.length; k++){
				if( constrs[k].deduceLogic(tmp) == false ){
					match = false;
					break;
				}
			}
			if( match == false ){
				continue;
			}

			// 制約不整合の検算
			reason = checkConstr(tmp);
			if( reason != "" ){
				if( turns.length == 0 ){
					// 一つ目の仮採用で不採用
					infeasibles[l] = reason;
				}
				continue;
			}

			// 論理関係不整合の検算
			reason = isPossible(tmp);
			if( reason != "" ){
				if( turns.length == 0 ){
					// 一つ目の仮採用で不採用
					infeasibles[l] = reason;
				}
				continue;
			}

			// workへ反映
			for(k = 0; k < len; k++){
				work[k] = tmp[k];
			}
calcmsg += "　【論理式" + (l + 1) + "】(mode=" + mode + ")\n" + dispLOGIC(work) + "\n";

			// 今回のテスト条件を生成する上で網羅
			vtestcov[l] = 1;
			// 採用した論理式番号
			turns[turns.length] = l;
			ret++;
		}
	}

	for(i = 0; i < len; i++){
		base[i] = work[i];
	}

	return ret;
}

//
// 配列 work の no 番目の値を value に設定する関数
// 設定不可ならば false
//
function chooseCauseValue(work, no, value, lnum)
{
	var		i, j, k, l;
	var		len		= nodes.length;
	var		tmp		= new Array(len);

	// 不適切な論理式か否か
	if( value == "T" || value == "t" ){
		if( unsuitables[lnum + 2*no] == 1 ){
			return false;
		}
	}
	else if( value == "F" || value == "f" ){
		if( unsuitables[lnum + 2*no + 1] == 1 ){
			return false;
		}
	}

	// tmpにコピー
	for(i = 0; i < len; i++){
		tmp[i]	= work[i];
	}

	tmp[no] = value;

	// 2011/02/12 論理関係の演繹計算を実施
	reason = deduce(tmp);
	if( reason != "" ){
		return false;
	}

	// 制約による演繹的な計算・検算
	match = true;
	for(k = 0; k < constrs.length; k++){
		if( constrs[k].deduceLogic(tmp) == false ){
			match = false;
			break;
		}
		if( constrs[k].maskLogic(tmp) == false ){
			match = false;
			break;
		}
	}
	if( match == false ){
		return false;
	}

	// 制約不整合の検算
	reason = checkConstr(tmp);
	if( reason != "" ){
		if( turns.length == 0 ){
			// 一つ目の仮採用で不採用
			infeasibles[l] = reason;
		}
		return false;
	}

	// 論理関係不整合の検算
	reason = isPossible(tmp);
	if( reason != "" ){
		if( turns.length == 0 ){
			// 一つ目の仮採用で不採用
			infeasibles[l] = reason;
		}
		return false;
	}

	// base へ反映
	work[no] = value;
	// 採用した原因ノード番号
	if( value == "T" ){
		turns[turns.length] = lnum + no*2;
	}
	else if( value == "F" ){
		turns[turns.length] = lnum + no*2 + 1;
	}

calcmsg += "　【原因ノード" + no + "】(" + value + ")\n" + dispLOGIC(work) + "\n";

	return true;
}

// 2010/08/21 カプセル化
function chooseCauseValue2(work, no, value, lnum, zoom)
{
	var		i, j, k, l;
	var		len		= nodes.length;
	var		tmp		= new Array(len);

	// 不適切な論理式か否か
	if( value == "T" || value == "t" ){
		if( unsuitables[lnum + 2*no] == 1 ){
			return false;
		}
	}
	else if( value == "F" || value == "f" ){
		if( unsuitables[lnum + 2*no + 1] == 1 ){
			return false;
		}
	}

	// tmpにコピー
	for(i = 0; i < len; i++){
		tmp[i]	= work[i];
	}

	tmp[no] = value;

	// 2011/02/12 論理関係の演繹計算を実施
	reason = deduce2(tmp, zoom);
	if( reason != "" ){
		return false;
	}
	// 制約による演繹的な計算・検算
	match = true;
	for(k = 0; k < constrs.length; k++){
		if( constrs[k].getZoom() != zoom ){
			continue;
		}

		if( constrs[k].deduceLogic(tmp) == false ){
			match = false;
			break;
		}
		if( constrs[k].maskLogic(tmp) == false ){
			match = false;
			break;
		}
	}
	if( match == false ){
		return false;
	}

	// 制約不整合の検算
	reason = checkConstr(tmp);
	if( reason != "" ){
		if( turns.length == 0 ){
			// 一つ目の仮採用で不採用
			infeasibles[l] = reason;
		}
		return false;
	}

	// 論理関係不整合の検算
	reason = isPossible(tmp);
	if( reason != "" ){
		if( turns.length == 0 ){
			// 一つ目の仮採用で不採用
			infeasibles[l] = reason;
		}
		return false;
	}

	// base へ反映
	work[no] = value;
	// 採用した原因ノード番号
	if( value == "T" ){
		turns[turns.length] = lnum + no*2;
	}
	else if( value == "F" ){
		turns[turns.length] = lnum + no*2 + 1;
	}

calcmsg += "　【原因ノード" + no + "】(" + value + ")\n" + dispLOGIC(work) + "\n";

	return true;
}

// 2010/08/22 カプセル化その2
function chooseCauseValue3(work, no, value, lnum, zoom)
{
	var		i, j, k, l;
	var		len		= nodes.length;
	var		tmp		= new Array(len);

	// 不適切な論理式か否か
	if( value == "T" || value == "t" ){
		if( unsuitables[lnum + 2*no] == 1 ){
			return false;
		}
	}
	else if( value == "F" || value == "f" ){
		if( unsuitables[lnum + 2*no + 1] == 1 ){
			return false;
		}
	}

	// tmpにコピー
	for(i = 0; i < len; i++){
		tmp[i]	= work[i];
	}

	tmp[no] = value;

	// 2011/02/12 論理関係の演繹計算を実施
	reason = deduce3(tmp, zoom);
	if( reason != "" ){
		return false;
	}

	// 制約による演繹的な計算・検算
	match = true;
	for(k = 0; k < constrs.length; k++){
		if( constrs[k].deduceLogic(tmp) == false ){
			match = false;
			break;
		}
		if( constrs[k].maskLogic(tmp) == false ){
			match = false;
			break;
		}
	}
	if( match == false ){
		return false;
	}

	// 制約不整合の検算
	reason = checkConstr(tmp);
	if( reason != "" ){
		if( turns.length == 0 ){
			// 一つ目の仮採用で不採用
			infeasibles[l] = reason;
		}
		return false;
	}

	// 論理関係不整合の検算
	reason = isPossible(tmp);
	if( reason != "" ){
		if( turns.length == 0 ){
			// 一つ目の仮採用で不採用
			infeasibles[l] = reason;
		}
		return false;
	}

	// base へ反映
	work[no] = value;
	// 採用した原因ノード番号
	if( value == "T" ){
		turns[turns.length] = lnum + no*2;
	}
	else if( value == "F" ){
		turns[turns.length] = lnum + no*2 + 1;
	}

calcmsg += "　【原因ノード" + no + "】(" + value + ")\n" + dispLOGIC(work) + "\n";

	return true;
}

function nextCondition(base, lnum)
{
	var		i, j, k, m, l;
	var		ii;
	var		len		= nodes.length;
	var		work	= new Array(len);
	var		ret		= 0;
	var		v		= null;
	var		match	= true;
	var		flag	= true;

	// 作業用配列にコピー
	for(i = 0; i < len; i++){
		work[i] = base[i];
	}

	// 最大でも lnum 回のテストで網羅できるはずなので
	for(i = 0; i < lnum; i++){
		// (1) まだ網羅されていない論理式を採用
		ret = chooseCondition(work, 0);
		if( turns.length == 0 && ret == 0 ){
			return false;
		}

		// (2) MASK制約による値決定
		for(j = 0; j < constrs.length; j++){
			constrs[j].maskLogic(work);
		}

		// (3) すでに網羅されている論理式を順次採用
		ret = chooseCondition(work, 1);

		// (4) 原因ノードを決定
		match = true;
		for(j = 0; j < len; j++){
			// 中間・結果ノードは省略
			if( nodes[j].getOp() != "" && nodes[j].getSeq() != "" ){
				continue;
			}

			// 既設定ノードは省略
			if( work[j] != "" ){
				continue;
			}

			// 関係を持たない原因ノードは省略
			flag = false;
			jQuery.each(nodes, function(k, val) {
				if( this.getOp() != "" && this.getSeq() != "" ){
					v = (this.getSeq()).split(",");

					if( v[j] == 1 ){
						flag = true;
					}
				}
			});
			if( flag == false ){
				continue;
			}


			if( chooseCauseValue(work, j, "t", lnum) == false ){
				if( chooseCauseValue(work, j, "f", lnum) == false ){
					// 再計算
calcmsg += "##### 再計算\n";
calcmsg += "##### turns = " + turns + "\n";
					if( turns[turns.length] < lnum ){
						vtestcov[turns[turns.length - 1]] = 0;
					}
					unsuitables[turns[turns.length - 1]] = 1;
					if( turns.length == 1 ){
calcmsg += "##### テスト不可能[論理式" + (turns[0] + 1) + "]\n";
						infeasibles[turns[0]] = "テスト不可能(*)";
					}
					turns.pop();
calcmsg += "##### turns = " + turns + "\n";

					// work再構築
					reCalc(work, lnum);
					match = false;
					break;
				}
			}
		}

		// 再計算したので(1)へ戻る
		if( match == false ){
			continue;
		}

		// (5) 演繹的に残りの値を決定
		reason = deduce(work);
		if( reason != "" ){
			if( turns.length > 0 ){
				// 最低でも1個の論理式を採用して、false
				infeasibles[turns[0]] = reason;
			}
			return false;
		}
calcmsg += "　【演繹計算】\n" + dispLOGIC(work) + "\n";

		// (6) Mが上書きした可能性があるので今回の網羅状況を再計算
		l = 0;
		lnum = 0;
		jQuery.each(nodes, function(j, val) {
			lnum = this.getLnum();
			for(k = 0; k < lnum; k++, l++){
				var		match = true;

				for(m = 0; m < len; m++){
					if( work[m] != "" && logics[l][m] != ""
						&& work[m] != logics[l][m] ){
						match = false;
						break;
					}
				}
				if( match == true ){
					vtestcov[l] = 1;
				}
				else{
					vtestcov[l] = 0;
				}
			}
		});

		// (7) 総合的に再計算
		covs[covs.length] = new Array(vtestcov.length);
		for(j = 0; j < vtestcov.length; j++){
			covs[covs.length - 1][j] = vtestcov[j];
		}
		for(j = 0; j < len; j++){
			base[j] = work[j];
		}

		break;
	}

	return true;
}

// 2010/08/22 カプセル化その2
function nextCondition3(base, lnum, zoom)
{
	var		i, j, k, m, l;
	var		ii;
	var		len		= nodes.length;
	var		work	= new Array(len);
	var		ret		= 0;
	var		v		= null;
	var		match	= true;
	var		flag	= true;

	// 作業用配列にコピー
	for(i = 0; i < len; i++){
		work[i] = base[i];
	}

	// 最大でも lnum 回のテストで網羅できるはずなので
	for(i = 0; i < lnum; i++){
		// (1) まだ網羅されていない論理式を採用
		ret = chooseCondition3(work, 0, zoom);
		if( turns.length == 0 && ret == 0 ){
			return false;
		}

		// (2) MASK制約による値決定
		for(j = 0; j < constrs.length; j++){
			if( zoom == -1 ){
				if( constrs[j].getZoom() == -1 ){
//					constrs[j].maskLogic(work);
// 2010/02/12 MASK制約に違反した場合は false
					if( constrs[j].maskLogic(work) == false ){
						return false;
					}
				}
			}
			else{
				if( constrs[j].getZoom() == zoom ){
//					constrs[j].maskLogic(work);
// 2010/02/12 MASK制約に違反した場合は false
					if( constrs[j].maskLogic(work) == false ){
						return false;
					}
				}
			}
		}

		// (3) すでに網羅されている論理式を順次採用
		ret = chooseCondition3(work, 1, zoom);

		// (4) 原因ノードを決定
		match = true;
		for(j = 0; j < len; j++){
			var		ntype	= nodes[j].getNodeType(zoom, j);

			// 中間・結果ノードは省略
			if( !(ntype == 0 || ntype == -1) ){
				continue;
			}

			// 既設定ノードは省略
			if( work[j] != "" ){
				continue;
			}

			// 関係を持たない原因ノードは省略
			flag = false;
			jQuery.each(nodes, function(k, val) {
				var		ntype	= this.getNodeType(zoom, k);

				if( !(ntype == 0 || ntype == -1) ){
					v = (this.getSeq()).split(",");

					if( v[j] == 1 ){
						flag = true;
					}
				}
			});
			if( flag == false ){
				continue;
			}


			if( chooseCauseValue3(work, j, "t", lnum, zoom) == false ){
				if( chooseCauseValue3(work, j, "f", lnum, zoom) == false ){
					// 再計算
calcmsg += "##### 再計算\n";
calcmsg += "##### turns = " + turns + "\n";
					if( turns[turns.length] < lnum ){
						vtestcov[turns[turns.length - 1]] = 0;
					}
					unsuitables[turns[turns.length - 1]] = 1;
					if( turns.length == 1 ){
calcmsg += "##### テスト不可能[論理式" + (turns[0] + 1) + "]\n";
						infeasibles[turns[0]] = "テスト不可能(*)";
					}
					turns.pop();
calcmsg += "##### turns = " + turns + "\n";

					// work再構築
					reCalc(work, lnum);
					match = false;
					break;
				}
			}
		}

		// 再計算したので(1)へ戻る
		if( match == false ){
			continue;
		}

		// (5) 演繹的に残りの値を決定
		reason = deduce3(work, zoom);
		if( reason != "" ){
			if( turns.length > 0 ){
				// 最低でも1個の論理式を採用して、false
				infeasibles[turns[0]] = reason;
			}
			return false;
		}
calcmsg += "　【演繹計算】\n" + dispLOGIC(work) + "\n";

		// (6) Mが上書きした可能性があるので今回の網羅状況を再計算
		l = 0;
		lnum = 0;
		jQuery.each(nodes, function(j, val) {
			lnum = this.getLnum();
			for(k = 0; k < lnum; k++, l++){
				var		match = true;

				for(m = 0; m < len; m++){
					if( work[m] != "" && logics[l][m] != ""
						&& work[m] != logics[l][m] ){
						match = false;
						break;
					}
				}
				if( match == true ){
					vtestcov[l] = 1;
				}
				else{
					vtestcov[l] = 0;
				}
			}
		});

		// (7) 総合的に再計算
		covs[covs.length] = new Array(vtestcov.length);
		for(j = 0; j < vtestcov.length; j++){
			covs[covs.length - 1][j] = vtestcov[j];
		}
		for(j = 0; j < len; j++){
			base[j] = work[j];
		}

		break;
	}

	return true;
}
