/** draw.js */

//////////////////////////////////////////////////////////////////////
function initCEGTest()
{
	var		pos	= $("#INPUTS").position();
	var		ss	= window.sessionStorage;
	var		data	= "";
	var		lines = null;
	var		heads	= null;
	var		nlen	= 0;
	var		clen	= 0;

	if( ss == undefined ){
		data = "";
	}
	else{
		data = ss.getItem("input-data");
	}

	initGRAPH();
	if( isIE == false ){
		dispELEMENT("MANUALS", pos.top, pos.left);
	}

// 2010/07/27 SessionStorageの復帰
	$("#IMPORT_CSV_GRAPH").val(data);

	if( data == null || data == "" ){
		return true;
	}
	lines = data.split("\n");
	if( lines[0] == null || lines[0] == "" ){
		return true;
	}
	heads = lines[0].split(",");
	nlen	= parseInt(heads[0]);
	clen	= parseInt(heads[1]);

	if( nlen > 0 || clen > 0 ){
		importCSV("前回の原因結果グラフを再構築しました");
	}

	return true;
}

//////////////////////////////////////////////////////////////////////
function initGRAPH()
{
	var		pos	= null;

	canvas		= document.getElementById("INPUTS");
	ctx			= canvas.getContext('2d');
	pos			= $("#INPUTS").position();
	root_top	= pos.top;
	root_left	= pos.left;

	if( !ctx ){
		dispMESSAGE("このブラウザではご利用できません", "#ff4500");
	}

	return true;
}

function clearGRAPH()
{
	canvas		= document.getElementById("INPUTS");
	ctx			= canvas.getContext('2d');
	ctx.clearRect(0, 0, $("#INPUTS").width(), $("#INPUTS").height());

	return true;
}

function sortGRAPH()
{
	var		i	= 0;
	var		str1	= "";
	var		str2	= "";

// 置換情報
	for(i = 0; i < subs.length; i++){
		str1 += subs[i] + ",";
	}

// 深さ計算
	jQuery.each(nodes, function(i, val){
		this.calcDepth();
	});

// 並べ替え
	subs.sort(posCompare);

// 置換情報
	for(i = 0; i < subs.length; i++){
		str2 += subs[i] + ",";
	}

	if( str1 == str2 ){
		return true;
	}
	else{
		return false;
	}
}

// ノード名をcanvas要素に出力
function imageGRAPH(top, left)
{
	var		i		= 0;

	// フォント設定
	ctx.font = "13px 'メイリオ'";

	// タイトル
	ctx.fillStyle = "#000000";
	ctx.fillText("title: " + g_ceg_title, 15, 15);

	// ノード
	jQuery.each(nodes, function(i, val){
		if( this.getZoom() == g_zoom || this.getZoom() == i ){
			this.drawText(top, left);
		}
	});

	// 制約
	jQuery.each(constrs, function(i, val){
		if( this.getZoom() == g_zoom ){
			this.drawText(top, left);
		}
	});

	return true;
}

function dispGRAPH()
{
	var		i		= 0;

	canvas		= document.getElementById("INPUTS");
	ctx			= canvas.getContext('2d');

	jQuery.each(nodes, function(i, val){
		// 2010/08/20 ズーム機能
		if( this.getZoom() == g_zoom ){
			if( this.getOrder() == true ){
				this.drawLines2(i);
			}
			else{
				this.drawLines(i);
			}
		}
	});
	jQuery.each(constrs, function(i, val){
		// 2010/08/20 ズーム機能
		if( this.getZoom() == g_zoom ){
			this.drawLines(i);
		}
	});

	return true;
}

//////////////////////////////////////////////////////////////////////
function setNODE(no, src, op)
{
	if( op == "AND" ){
		$("#N" + no).attr("title", src);
		$("#NOP" + no).text("∧");
		$("#NTEXT" + no).text(src);
	}
	else if( op == "OR" ){
		$("#N" + no).attr("title", src);
		$("#NOP" + no).text("∨");
		$("#NTEXT" + no).text(src);
	}
	else{
		$("#N" + no).attr("title", src);
		$("#NOP" + no).text("");
		$("#NTEXT" + no).text(src);
	}
	return true;
}

function insertNODE(flag)
{
	var		txt		= $("#TEXT_NODE").val();
	var		pos		= $("#TEXT_NODE").position();
	var		len		= nodes.length;
	var		i, j;

	if( len >= 100 ){
		dispMESSAGE("配置できるノードは最大で" + len + "個です", "#ff4500");
	}
	else{
		if( txt == "" ){
			txt = "ノード" + (len + 1);
		}

		// 描写
		if( flag == true ){
			setNODE(len, txt, "");
			$("#N" + len)
			.css("top", (pos.top) + "px")
			.css("left", (pos.left) + "px")
			.show();
		}
		else{
			setNODE(len, txt, "");
			$("#N" + len)
			.css("top", root_top + "px")
			.css("left", root_left + "px")
			.show();
		}

		// NODEオブジェクトへの追加
		nodes[len] = new NODE(txt);
		nodes[len].setTop(pos.top);
		nodes[len].setLeft(pos.left);
		nodes[len].setWidth($("#N" + len).width());
		nodes[len].setHeight($("#N" + len).height());

		// 2010/07/19 置換の追加と並べ替え
		subs[len] = len;
		subs.sort(posCompare);

		// 論理関係の修正
		jQuery.each(nodes, function(i, val){
			var		seq	= this.getSeq();
			var		lnum = this.getLnum();
			var		r	= null;
			var		newseq	= "";

			if( seq != "" ){
				r = seq.split(",");
				for(j = 0; j < len; j++){
					newseq += r[j] + ",";
				}
				newseq += "0,";
				for(j = 0; j < len; j++){
					newseq += r[(j + len)] + ",";
				}
				newseq += "0,";
				this.setSeq(newseq);
			}
		});

		// 制約の seq を修正
		jQuery.each(constrs, function(i, val){
			var		seq	= this.getSeq();
			var		r	= null;
			var		newseq	= "";

			if( seq != "" ){
				r = seq.split(",");

				for(j = 0; j < len; j++){
					newseq += r[j] + ",";
				}
				newseq += "0,";
				for(j = 0; j < len; j++){
					newseq += r[j + len] + ",";
				}
				newseq += "0,";
				for(j = 0; j < len; j++){
					newseq += r[j + 2*len] + ",";
				}
				newseq += "0,";
				for(j = 0; j < len; j++){
					newseq += r[j + 3*len] + ",";
				}
				newseq += "0,";
				this.setSeq(newseq);
			}
		});

		$("#TEXT_NODE").val("");
		$("#TEXT_NODE2").focus();

logmsg += "NODE " + txt + " (" + pos.top + "," + pos.left + ")\n";
		dispMESSAGE(nodes[len].getText() + " を配置しました。", "#f8e58c");
	}

	return len;
}

function updateNODE()
{
	var		no		= $("#TEXT_UPDATE").attr("no");
	var		txt		= $("#TEXT_NODE2").val();
	var		obs		= $("#OBS_NODE").attr("checked");
	var		order	= $("#ORDER_NODE").attr("checked");
	var		memo	= $("#MEMO_NODE").val();
	var		extxt	= nodes[no].getText();
	var		exobs	= nodes[no].getObs();
	var		exmemo	= nodes[no].getMemo();

	if( txt == "" ){
		txt = nodes[no].getText();
	}

	// 描写
	setNODE(no, txt, nodes[no].getOp());

	// NODEオブジェクトへの反映
	nodes[no].setText(txt);
	nodes[no].setObs(obs);
	nodes[no].setOrder(order);
	nodes[no].setMemo(memo);
	nodes[no].setWidth($("#N" + no).width());
	nodes[no].setHeight($("#N" + no).height());

logmsg += "NODE " + extxt + " -> " + txt + "\n";
	dispMESSAGE(nodes[no].getText() + " を変更", "#f8e58c");
	hideELEMENT("TEXT_UPDATE");
	clearGRAPH();	// 2010/06/28 表示不具合のため
	sortGRAPH();	// 2010/07/19 並べ替え
	dispGRAPH();
	dispOUTPUTS();

	return true;
}

function deleteNODE(no)
{
	var		i, j;
	var		len		= nodes.length;
	var		text	= nodes[no].getText();

	nodes = jQuery.grep(nodes, function(n, i){
		return (i != no);
	});
// 2010/07/19 置換オブジェクトの削除
	subs = new Array();
	for(i = 0; i < nodes.length; i++){
		subs[i] = i;
	}

	// 論理関係の修正
	jQuery.each(nodes, function(i, val){
		var		seq	= this.getSeq();
		var		lnum = this.getLnum();
		var		r	= null;
		var		newseq	= "";

		if( seq != "" ){
			r = seq.split(",");
			for(j = 0; j < len; j++){
				if( j != no ){
					newseq += r[j] + ",";
				}
			}
			for(j = 0; j < len; j++){
				if( j != no ){
					newseq += r[(j + len)] + ",";
				}
			}
			this.setSeq(newseq);
			this.setLnum(lnum - 1);
		}
	});

	// 制約の修正
	jQuery.each(constrs, function(i, val){
		var		seq	= this.getSeq();
		var		r	= null;
		var		newseq	= "";

		if( seq != "" ){
			r = seq.split(",");
			for(j = 0; j < len; j++){
				if( j != no ){
					newseq += r[j] + ",";
				}
			}
			for(j = 0; j < len; j++){
				if( j != no ){
					newseq += r[(j + len)] + ",";
				}
			}
			for(j = 0; j < len; j++){
				if( j != no ){
					newseq += r[(j + 2*len)] + ",";
				}
			}
			for(j = 0; j < len; j++){
				if( j != no ){
					newseq += r[(j + 3*len)] + ",";
				}
			}
			this.setSeq(newseq);
		}
	});

	for(i = no; i < 100; i++){
		$("#N" + i)
		.css("width", "")
		.css("height", "")
		.hide();
	}
	jQuery.each(nodes, function(i, val){
		setNODE(i, this.getText(), this.getOp());
//		$("#N" + i)
//		.css("top", this.getTop() + "px")
//		.css("left", this.getLeft() + "px")
//		.css("width", this.getWidth() + "px")
//		.css("height", this.getHeight() + "px")
//		.show();
		// 2010/06/28 ノード削除時の表示不具合のため
		$("#N" + i)
		.css("top", this.getTop() + "px")
		.css("left", this.getLeft() + "px")
		.show();
	});

	// 2010/02/14 ノード削除時の表示不具合のため
	$("#N" + nodes.length)
	.css("width", "")
	.css("height", "")
	.hide();

logmsg += "NODE " + text + " DELETE\n";
	dispMESSAGE(text + "を削除しました", "#f8e58c");
	clearGRAPH();
	sortGRAPH();	// 2010/07/19 並べ替え
	dispGRAPH();
	// 2010/07/19 ノード削除時の不具合対応
//	dispOUTPUTS();
	// 2010/07/22 インポート後のノード削除で不具合があったため対応
	$("#IMPORT_CSV_GRAPH").val(getEXPORT_CSV_GRAPH());
	adjustGraph(text + "を削除しました");
	return true;
}

function opNODE(no, op)
{
	// 描写
	setNODE(no, nodes[no].getText(), op);

	// NODEオブジェクトへの反映
	nodes[no].setOp(op);
	if( op == "" ){
		nodes[no].setSeq("");
		nodes[no].setLnum(1);
	}
	nodes[no].setWidth($("#N" + no).width());
	nodes[no].setHeight($("#N" + no).height());

	if( op == "" ){
		dispMESSAGE(nodes[no].getText()
			+ " の論理関係をクリアしました",
			"#f8e58c");
	}
	else{
		dispMESSAGE(nodes[no].getText()
			+ " の論理関係 " + op + " を設定しました",
			"#f8e58c");
	}

if( op == "" ){
logmsg += "NODE " + nodes[no].getText() + " CLEAR\n";
}
else{
logmsg += "NODE " + nodes[no].getText() + " " + op + "\n";
}
	hideELEMENT("TEXT_UPDATE");
	return true;
}

//////////////////////////////////////////////////////////////////////
function insertCONSTR(type, top, left)
{
	var		len		= constrs.length;

	if( len >= 100 ){
		dispMESSAGE("配置できる制約は最大で" + len + "個です", "#ff4500");
	}
	else{
		// 描写
		$("#C" + len)
		.text(type)
		.css("top", (top) + "px")
		.css("left", (left) + "px")
		.show();

		// CONSTRオブジェクトへの追加
		constrs[len] = new CONSTR(type);
		constrs[len].setTop(top);
		constrs[len].setLeft(left);
		constrs[len].setWidth($("#C" + len).width());
		constrs[len].setHeight($("#C" + len).height());

logmsg += "CONSTR " + type + " (" + top + "," + left + ")\n";
	}

	return len;
}

function deleteCONSTR(no)
{
	var		i		= 0;
	var		type	= constrs[no].getType();

	constrs = jQuery.grep(constrs, function(n, i){
		return (i != no);
	});

	for(i = no; i < 100; i++){
		$("#C" + i).hide();
	}
	jQuery.each(constrs, function(i, val){
		$("#C" + i)
		.text(this.getType())
		.css("top", this.getTop() + "px")
		.css("left", this.getLeft() + "px")
		.show();
	});

logmsg += "CONSTR " + type + " DELETE\n";
	dispMESSAGE(type + " 制約(" + no + ")を削除しました", "#f8e58c");
	clearGRAPH();
	sortGRAPH();	// 2010/07/19 並べ替え
	dispGRAPH();
//	dispOUTPUTS();
	$("#IMPORT_CSV_GRAPH").val(getEXPORT_CSV_GRAPH());
	adjustGraph(type + "を削除しました");

	return true;
}

function updateCONSTR(no, type)
{
	var		extype	= constrs[no].getType();

	if( type == extype ){
		return true;
	}

	constrs[no].setType(type);
	constrs[no].setWidth($("#C" + no).width());
	constrs[no].setHeight($("#C" + no).height());
	$("#C" + no).text(type);

logmsg += "CONSTR " + extype + " -> " + type + "\n";
	dispMESSAGE(type + " 制約(" + no + ")を " + type + "に変更しました", "#f8e58c");
	clearGRAPH();
	sortGRAPH();	// 2010/07/19 並べ替え
	dispGRAPH();
	dispOUTPUTS();

	return true;
}

//////////////////////////////////////////////////////////////////////

function crossLine(top, left)
{
	var		nlen	= nodes.length;
	var		clen	= constrs.length;
	var		i		= 0;
	var		j		= 0;
	var		cut		= false;

	for(i = 0; i < nlen; i++){
		var		seq	= nodes[i].getSeq();

		if( seq != "" ){
			var		r	= seq.split(",");
			var		x1	= 0;
			var		y1	= 0;
			var		x2	= 0;
			var		y2	= 0;
			var		degree1	= 0;
			var		degree2	= 0;

			x2 = nodes[i].getLeft();
			y2 = nodes[i].getTop() + (nodes[i].getHeight())/2;
			degree2 = Math.atan2(y2 - top, x2 - left);
			for(j = 0; j < nlen; j++){
				if( r[j] != 1 ){
					continue;
				}

				x1 = nodes[j].getLeft() + nodes[j].getWidth();
				y1 = nodes[j].getTop() + (nodes[j].getHeight())/2;
				degree1	= Math.atan2(y2 - y1, x2 - x1);

				if( Math.abs(degree1 - degree2) < (Math.PI * 1) / 180
					&& Math.abs(left - x2) < Math.abs(x1 - x2) ){
					// リンクの取り消し
					nodes[i].addSeq(j, 0, 0);
					hideSUBS();
					// グラフの再描画
					clearGRAPH();
					sortGRAPH();
					dispGRAPH();
					dispOUTPUTS();
					dispMESSAGE("ラインを削除しました", "#f8e58c");
					cut = true;
					break;
				}
			}
		}

		if( cut == true ){
			break;
		}
	}

	if( cut == true ){
		return true;
	}

	return true;

// 2010/08/01 以下、作成中
	for(i = 0; i < clen; i++){
		var		seq	= constrs[i].getSeq();

		if( seq != "" ){
			var		r	= seq.split(",");
			var		x1	= 0;
			var		y1	= 0;
			var		x2	= 0;
			var		y2	= 0;
			var		degree1	= 0;
			var		degree2	= 0;

			x2 = constrs[i].getLeft() + constrs[i].getWidth();
			y2 = constrs[i].getTop() + (constrs[i].getHeight())/2;
			degree2 = Math.atan2(y2 - top, x2 - left);
			for(j = 0; j < nlen; j++){
				if( r[j] != 1 ){
					continue;
				}

				x1 = nodes[j].getLeft();
				y1 = nodes[j].getTop() + (nodes[j].getHeight())/2;
				degree1	= Math.atan2(y2 - y1, x2 - x1);

				if( Math.abs(degree1 - degree2) < (Math.PI * 1) / 180
					&& Math.abs(left - x2) < Math.abs(x1 - x2) ){
					// リンクの取り消し
					constrs[i].addSeqStart(j, 0, 0);
					hideSUBS();
					// グラフの再描画
					clearGRAPH();
					sortGRAPH();
					dispGRAPH();
					dispOUTPUTS();
					dispMESSAGE("ラインを削除しました", "#f8e58c");
					cut = true;
					break;
				}
			}

			for(j = 0; j < nlen; j++){
				if( r[j + 2*nlen] != 1 ){
					continue;
				}

				x1 = nodes[j].getLeft();
				y1 = nodes[j].getTop() + (nodes[j].getHeight())/2;
				degree1	= Math.atan2(y2 - y1, x2 - x1);

				if( Math.abs(degree1 - degree2) < (Math.PI * 1) / 180
					&& Math.abs(left - x2) < Math.abs(x1 - x2) ){
					// リンクの取り消し
					constrs[i].addSeqEnd(j, 0, 0);
					hideSUBS();
					// グラフの再描画
					clearGRAPH();
					sortGRAPH();
					dispGRAPH();
					dispOUTPUTS();
					dispMESSAGE("ラインを削除しました", "#f8e58c");
					cut = true;
					break;
				}
			}
		}

		if( cut == true ){
			break;
		}
	}

	return true;
}

//////////////////////////////////////////////////////////////////////

function adjustGraph(message)
{
	$("#IMPORT_CSV_GRAPH").text(getEXPORT_CSV_GRAPH());
	importCSV(message);
	return true;
}

function importCSV(message)
{
	var		i, j;
	var		data	= $("#IMPORT_CSV_GRAPH").val();
	var		lines	= null;
	var		heads	= null;
	var		nlen,clen;
	var		start	= 0;
	var		v		= null;
	var		stime, etime;

	stime = new Date();

	hideSUBS();

	if( data == null || data == "" ){
		dispMESSAGE("インポートデータがありません", "#ff4500");
		return false;
	}
	lines = data.split("\n");
	if( lines[0] == null || lines[0] == "" ){
		dispMESSAGE("インポートデータのデータ形式が不正です(1)", "#ff4500");
		return false;
	}
	heads = lines[0].split(",");
	nlen	= parseInt(heads[0]);
	clen	= parseInt(heads[1]);

	// CSV validation

	// INPUTS initiation
	clearALL();

	// nodes
	start = 1;
	for(i = 0; i < nlen; i++){
		$("#TEXT_NODE").val(lines[start + i]);
		insertNODE(false);
	}

	// nodes' properties
	start += nlen;
	for(i = 0; i < nlen; i++){
		var		r	= lines[start + i].split(",");

		nodes[i].setTop(parseInt(r[0]));
		nodes[i].setLeft(parseInt(r[1]));
		nodes[i].setWidth(parseInt(r[2]));
		nodes[i].setHeight(parseInt(r[3]));
		dispELEMENT("N" + i, parseInt(r[0]), parseInt(r[1]));
		if( r[4] != "obs" ){
			nodes[i].setObs(false);
		}
	}
	for(i = 0; i < nlen; i++){
		var		r	= lines[start + i].split(",");
		var		len	= nodes.length;

		if( r[5] == "AND" || r[5] == "OR" ){
			opNODE(i, r[5]);
			for(j = 0; j < len; j++){
				if( parseInt(r[6 + j]) != 1 ){
					continue;
				}

				nodes[i].addSeq(j, 1, parseInt(r[6 + len + j]));
if( parseInt(r[6 + len + j]) == 1 ){
logmsg += "LINE " + nodes[j].getText() + " => NOT " + nodes[i].getText() + "\n";
}
else{
logmsg += "LINE " + nodes[j].getText() + " => " + nodes[i].getText() + "\n";
}
			}
		}
	}

	// constrs
	start += nlen;
	for(i = 0; i < clen; i++){
		var		r	= lines[start + i].split(",");

		insertCONSTR(r[0], parseInt(r[1]), parseInt(r[2]));
		constrs[i].setWidth(parseInt(r[3]));
		constrs[i].setHeight(parseInt(r[4]));
	}
	for(i = 0; i < clen; i++){
		var		r	= lines[start + i].split(",");
		var		len	= nodes.length;

		if( r[0] == "ONE" || r[0] == "EXCL" || r[0] == "INCL" ){
			for(j = 0; j < len; j++){
				if( parseInt(r[5 + 2*len + j]) != 1 ){
					continue;
				}

				constrs[i].addSeqEnd(j, 1, parseInt(r[5 + 3*len + j]));
if( parseInt(r[5 + 3*len + j]) == 1 ){
logmsg += "LINE " + constrs[i].getType() + " => NOT " + nodes[j].getText() + "\n";
}
else{
logmsg += "LINE " + constrs[i].getType() + " => " + nodes[j].getText() + "\n";
}
			}
		}
		else{
			for(j = 0; j < len; j++){
				if( parseInt(r[5 + j]) != 1 ){
					continue;
				}

				constrs[i].addSeqStart(j, 1, parseInt(r[5 + len + j]));
if( parseInt(r[5 + len + j]) == 1 ){
logmsg += "LINE NOT " + nodes[j].getText() + " => " + constrs[i].getType() + "\n";
}
else{
logmsg += "LINE " + nodes[j].getText() + " => " + constrs[i].getType() + "\n";
}

				break;
			}
			for(j = 0; j < len; j++){
				if( parseInt(r[5 + 2*len + j]) != 1 ){
					continue;
				}

				constrs[i].addSeqEnd(j, 1, parseInt(r[5 + 3*len + j]));
if( parseInt(r[5 + 3*len + j]) == 1 ){
logmsg += "LINE " + constrs[i].getType() + " => NOT " + nodes[j].getText() + "\n";
}
else{
logmsg += "LINE " + constrs[i].getType() + " => " + nodes[j].getText() + "\n";
}
			}
		}
	}

	clearGRAPH();
	// 2010/07/19 NODEオブジェクトの並べ替え
	sortGRAPH();
	dispGRAPH();
	dispOUTPUTS();

	etime = new Date();

	if( message == null || message == "" ){
		dispMESSAGE("インポートが成功しました [" + (etime - stime) + " ミリ秒]", "#f8e58c");
	}
	else{
		dispMESSAGE(message, "#f8e58c");
	}

	return true;
}

function importXCEG()
{
	alert("未実装です");

	return true;
}

//////////////////////////////////////////////////////////////////////

function saveCanvas()
{
	alert("未実装です");

	return true;
}

