//////////////////////////////////////////////////////////////////////
// NODE
// CHANGELOG
//  2010.05.06 checkRelation()
//////////////////////////////////////////////////////////////////////

function NODE(text)
{
	this.text		= text;				// ノード名
	this.obs		= true;				// 観測可能性
	this.order		= false;			// 判定順序
	this.op			= "";				// AND/OR
	this.seq		= "";				// 論理関係
	this.lnum		= 1;				// このノードに関する論理展開式数
	this.depth		= 0;				// 深さ
	this.top		= 0;				// 表示位置
	this.left		= 0;				// 表示位置
	this.width		= 0;				// 表示幅
	this.height		= 0;				// 表示高
	this.effect		= true;				// 結果ノードか否か
	this.memo		= "";				// メモ
	this.zoom		= -1;				// ズーム番号

	// GET
	this.getText		= function()
	{
		return this.text;
	}

	this.getObs			= function()
	{
		return this.obs;
	}

	this.getOrder		= function()
	{
		return this.order;
	}

	this.getOp			= function()
	{
		return this.op;
	}

	this.getSeq			= function()
	{
		return this.seq;
	}

	this.getTop			= function()
	{
		return this.top;
	}

	this.getLeft		= function()
	{
		return this.left;
	}

	this.getWidth		= function()
	{
		return this.width;
	}

	this.getHeight		= function()
	{
		return this.height;
	}

	this.getLnum		= function()
	{
		if( this.lnum == 1 ){
			return 0;
		}
		else{
			return this.lnum;
		}
	}

	this.getDepth		= function()
	{
		return this.depth;
	}

	this.getLogicValue	= function(no, col, row)
	{
		var		i		= 0;
		var		count	= 0;
		var		len		= nodes.length;
		var		v		= null;

		r = (this.seq).split(',');

		if( this.op == "AND" ){
			if( col == 0 ){
				if( no == row ){
					return "T";
				}
				else if( r[row] == 1 ){
					if( r[len + row] == 1 ){
						return "F";
					}
					else{
						return "T";
					}
				}
				else{
					return "";
				}
			}
			else{
				if( no == row ){
					return "F";
				}
				else if( r[row] == 1 ){
					for(count = 0, i = 0; i < row; i++){
						if( r[i] == 1 ){
							count++;
						}
					}
					if( (col - 1) == count ){
						if( r[len + row] == 1 ){
							return "T";
						}
						else{
							return "F";
						}
					}
					else{
						if( r[len + row] == 1 ){
							return "F";
						}
						else{
							return "T";
						}
					}
				}
				else{
					return "";
				}
			}
		}
		else if( this.op == "OR" ){
			if( col == (this.lnum - 1) ){
				if( no == row ){
					return "F";
				}
				else if( r[row] == 1 ){
					if( r[len + row] == 1 ){
						return "T";
					}
					else{
						return "F";
					}
				}
				else{
					return "";
				}
			}
			else{
				if( no == row ){
					return "T";
				}
				else if( r[row] == 1 ){
					for(count = 0, i = 0; i < row; i++){
						if( r[i] == 1 ){
							count++;
						}
					}
					if( col == count ){
						if( r[len + row] == 1 ){
							return "F";
						}
						else{
							return "T";
						}
					}
					else{
						if( r[len + row] == 1 ){
							return "T";
						}
						else{
							return "F";
						}
					}
				}
				else{
					return "";
				}
			}
		}
		else{
			return "";
		}
	}

	this.getMemo		= function()
	{
		return this.memo;
	}

	this.getZoom		= function()
	{
		return this.zoom;
	}

	this.getNodeType	= function(zoom, no)
	{
		// 原因(0) or 中間(1) or 結果(2) or 隠ぺい(-1)
		if( zoom == -1 ){
			// 通常時あるいはズームアウト時
			if( this.zoom == no ){
				return 0;
			}
			else if( this.zoom != -1 ){
				return -1;
			}
			else if( this.op == "" ){
				return 0;
			}
			else if( this.effect == true ){
				return 2;
			}
			else{
				return 1;
			}
		}
		else{
			// nodes[zoom] をズームイン
			if( this.zoom == no ){
				return 2;
			}
			else if( this.zoom == zoom ){
				// ズームイン対象
				if( this.op == "" ){
					return 0;
				}
				else{
					return 1;
				}
			}
			else{
				// 無視
				return -1;
			}
		}
		// unreachable
	}

	// SET
	this.setText		= function(text)
	{
		this.text	= text;
		return true;
	}

	this.setObs			= function(obs)
	{
		this.obs	= obs;
		return true;
	}

	this.setOrder		= function(order)
	{
		this.order	= order;
		return true;
	}

	this.setOp			= function(op)
	{
		this.op		= op;
		return true;
	}

	this.setSeq			= function(seq)
	{
		this.seq	= seq;
		return true;
	}

	this.setLnum		= function(lnum)
	{
		this.lnum	= lnum;
		return true;
	}

	this.setTop			= function(top)
	{
		this.top	= top;
		return true;
	}

	this.setLeft			= function(left)
	{
		this.left	= left;
		return true;
	}

	this.setWidth			= function(width)
	{
		this.width	= width;
		return true;
	}

	this.setHeight			= function(height)
	{
		this.height	= height;
		return true;
	}

	this.setEffect				= function(effect)
	{
		this.effect		= effect;
		return effect;
	}

	this.setMemo				= function(memo)
	{
		this.memo		= memo;
		return true;
	}

	this.setZoom				= function(zoom)
	{
		this.zoom		= zoom;
		return true;
	}

	// UTIL
	this.exprSeq			= function()
	{
		var		i;
		var		count = 0;
		var		len	= nodes.length;
		var		r	= this.seq.split(",");
		var		txt	= "";

		txt += this.text + "=(";
		count = 0;
		for(i = 0; i < len; i++){
			if( r[i] != 1 ){
				continue;
			}
			if( r[i + len] == 1 ){
				if( count == 0 ){
					txt += "NOT " + nodes[i].getText();
				}
				else{
					txt += " " + this.op + " NOT " + nodes[i].getText();
				}
			}
			else{
				if( count == 0 ){
					txt += nodes[i].getText();
				}
				else{
					txt += " " + this.op + " " + nodes[i].getText();
				}
			}
			count++;
		}
		txt += ")";

		return txt;
	}

	this.calcDepth			= function()
	{
		var		depth	= 0;
		var		i	= 0;
		var		r	= this.seq.split(",");

		if( this.op == "" ){
			this.depth = 0;
			return true;
		}

		for(i = 0; i < nodes.length; i++){
			if( r[i] == 1 ){
				if( nodes[i].getDepth() == 0 ){
					nodes[i].calcDepth();
				}
				if( depth < nodes[i].getDepth() + 1 ){
					depth = nodes[i].getDepth() + 1;
				}
			}
		}
		this.depth = depth;
	}

	this.getCause			= function(list)
	{
		var		i	= 0;
		var		r	= this.seq.split(",");

		if( this.op == "" ){
			return true;
		}

		for(i = 0; i < nodes.length; i++){
			if( r[i] != 1 ){
				continue;
			}

			list[i] = 1;
			nodes[i].getCause(list);
		}

		return true;
	}

	this.isEffect			= function()
	{
		return this.effect;
	}

	this.checkRelation		= function(src, no)
	{
		var		i		= 0;
		var		len		= nodes.length;
		var		v		= (this.seq).split(",");
		var		count	= 0;
		var		expect	= "";
		var		mask	= 0;
		var		unknown	= 0;

		if( src[no] == "" ){
			return true;
		}
		if( this.op == "" || this.seq == "" ){
			return true;
		}

		if( this.op == "AND" ){
			for(i = 0; i < len; i++){
				if( v[i] != 1 ){
					continue;
				}

				count++;
				if( v[len + i] == 1 ){
					// NOT
					if( src[i] == "T" || src[i] == "t" ){
						expect = "F";
						break;
					}
					else if( src[i] == "M" ){
						mask++;
					}
					else if( src[i] == "F" || src[i] == "f" ){
						expect = "T";
					}
					else{
						unknown++;
					}
				}
				else{
					if( src[i] == "F" || src[i] == "f" ){
						expect = "F";
						break;
					}
					else if( src[i] == "M" ){
						mask++;
					}
					else if( src[i] == "T" || src[i] == "t" ){
						expect = "T";
					}
					else{
						unknown++;
					}
				}
			}

			if( (src[no] == "T" || src[no] == "t")
				&& expect == "F" && unknown == 0 ){
				return false;
			}
			if( (src[no] == "F" || src[no] == "f")
				&& expect == "T" && unknown == 0 ){
				return false;
			}
// 2011/02/12 src[no] == MASK の場合を追加
			if( src[no] == "M" ){
				if( unknown == 0 && mask == 0 ){
					// 全ての原因が明らかであり、かつ、M はなりえない
					return false;
				}
				if( expect == "F" ){
					// F であるはずが M となっている
					return false;
				}
			}

			return true;
		}
		else if( this.op == "OR" ){
			for(i = 0; i < len; i++){
				if( v[i] != 1 ){
					continue;
				}

				count++;
				if( v[len + i] == 1 ){
					// NOT
					if( src[i] == "F" || src[i] == "f" ){
						expect = "T";
						break;
					}
					else if( src[i] == "T" || src[i] == "t" ){
						expect = "F";
					}
					else if( src[i] == "" ){
						unknown++;
					}
				}
				else{
					if( src[i] == "T" || src[i] == "t" ){
						expect = "T";
						break;
					}
					else if( src[i] == "F" || src[i] == "f" ){
						expect = "F";
					}
					else if( src[i] == "" ){
						unknown++;
					}
				}
			}

			if( (src[no] == "T" || src[no] == "t")
				&& expect == "F" && unknown == 0 ){
				return false;
			}
			if( (src[no] == "F" || src[no] == "f")
				&& expect == "T" && unknown == 0 ){
				return false;
			}
// 2011/02/12 src[no] == MASK の場合を追加
			if( src[no] == "M" ){
				if( unknown == 0 && mask == 0 ){
					// 全ての原因が明らかであり、かつ、M はなりえない
					return false;
				}
				if( expect == "T" ){
					// T であるはずが M となっている
					return false;
				}
			}

			return true;
		}
	}

	this.addSeq				= function(no, value, not)
	{
		var		len		= nodes.length;
		var		i		= 0;

		if( this.seq == "" ){
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += value + ",";
				}
				else{
					this.seq += "0,";
				}
			}
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += not + ",";
				}
				else{
					this.seq += "0,";
				}
			}
		}
		else{
			var		r	= this.seq.split(",");

			this.seq = "";
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += value + ",";
				}
				else{
					this.seq += r[i] + ",";
				}
			}
			for(i = 0; i < len; i++){
				if( i == no ){
					this.seq += not + ",";
				}
				else{
					this.seq += r[len + i] + ",";
				}
			}
		}

		if( value == 1 ){
			this.lnum++;
		}
		else{
			this.lnum--;
		}
		return true;
	}

	this.drawLines			= function(no)
	{
		var		i		= 0;
		var		len		= nodes.length;
		var		r		= null;
		var		pos		= null;
		var		x1		= 0;
		var		x2		= 0;
		var		y1		= 0;
		var		y2		= 0;
		var		aX		= null;
		var		aY		= null;
		var		degree	= 0;

		if( this.seq == "" ){
			return true;
		}

		r = this.seq.split(",");
		x2 = nodes[no].getLeft();
		y2 = nodes[no].getTop() + (nodes[no].getHeight())/2;
		for(i = 0; i < len; i++){
			if( r[i] != 1 ){
				continue;
			}

			x1 = nodes[i].getLeft() + nodes[i].getWidth();
			y1 = nodes[i].getTop() + (nodes[i].getHeight())/2;
			degree	= Math.atan2(y2 - y1, x2 - x1);

			if( r[i + len] == 1 ){
				ctx.lineWidth	= 1;
				ctx.strokeStyle	= "#ffa500";

				// 否定記号
				ctx.beginPath();
				ctx.moveTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
				ctx.bezierCurveTo(
					(x1 + x2)/2 + nalen*Math.cos(degree - narc),
					(y1 + y2)/2 + nalen*Math.sin(degree - narc) - root_top,
					(x1 + x2)/2 + nalen*Math.cos(degree + narc),
					(y1 + y2)/2 + nalen*Math.sin(degree + narc) - root_top,
					(x1 + x2)/2 + nalen*Math.cos(degree + narc)
						+ nalen*Math.cos(degree - narc),
					(y1 + y2)/2 + nalen*Math.sin(degree + narc)
						+ nalen*Math.sin(degree - narc) - root_top);
				// 線分
				ctx.moveTo(x1, y1 - root_top);
				ctx.lineTo(x2, y2 - root_top);
				ctx.stroke();
			}
			else{
				ctx.lineWidth	= 1;
				ctx.strokeStyle	= "#000000";
				// 線分
				ctx.beginPath();
				ctx.moveTo(x1, y1 - root_top);
				ctx.lineTo(x2, y2 - root_top);
				ctx.stroke();
			}

		}

		return true;
	}

	this.drawLines2			= function(no)
	{
		var		i		= 0;
		var		total	= 0;
		var		count	= 0;
		var		len		= nodes.length;
		var		r		= null;
		var		pos		= null;
		var		std_x	= 0;
		var		std_y	= 0;
		var		b_x		= 0;
		var		b_y		= 0;
		var		x1		= 0;
		var		x2		= 0;
		var		y1		= 0;
		var		y2		= 0;
		var		aX		= null;
		var		aY		= null;
		var		degree	= 0;

		if( this.seq == "" ){
			return true;
		}

		r = this.seq.split(",");
		x2 = nodes[no].getLeft();
		y2 = nodes[no].getTop() + (nodes[no].getHeight())/2;

		for(i = 0; i < len; i++){
			if( r[i] != 1 ){
				continue;
			}
			total++;
		}

		for(i = 0; i < len; i++){
			if( r[subs[i]] != 1 ){
				continue;
			}

			x1 = nodes[subs[i]].getLeft() + nodes[subs[i]].getWidth();
			y1 = nodes[subs[i]].getTop() + (nodes[subs[i]].getHeight())/2;

			if( r[subs[i] + len] == 1 ){
				ctx.lineWidth	= 1;
				ctx.strokeStyle	= "#ffa500";

				if( count == 0 ){
					// 否定記号
					degree	= Math.atan2(y2 - y1, x2 - x1);
					ctx.beginPath();
					ctx.moveTo((x1 + x2)/2, (y1 + y2)/2 - root_top);
					ctx.bezierCurveTo(
						(x1 + x2)/2 + nalen*Math.cos(degree - narc),
						(y1 + y2)/2 + nalen*Math.sin(degree - narc) - root_top,
						(x1 + x2)/2 + nalen*Math.cos(degree + narc),
						(y1 + y2)/2 + nalen*Math.sin(degree + narc) - root_top,
						(x1 + x2)/2 + nalen*Math.cos(degree + narc)
							+ nalen*Math.cos(degree - narc),
						(y1 + y2)/2 + nalen*Math.sin(degree + narc)
							+ nalen*Math.sin(degree - narc) - root_top);
					// 線分
					ctx.moveTo(x1, y1 - root_top);
					ctx.lineTo(x2, y2 - root_top);
					std_x = x1;
					std_y = y1;
				}
				else{
					b_x = std_x + (x2 - std_x)*(count / total);
					b_y = std_y + (y2 - std_y)*(count / total);

					// 否定記号
					degree	= Math.atan2(b_y - y1, b_x - x1);
					ctx.beginPath();
					ctx.moveTo((x1 + b_x)/2, (y1 + b_y)/2 - root_top);
					ctx.bezierCurveTo(
						(x1 + b_x)/2 + nalen*Math.cos(degree - narc),
						(y1 + b_y)/2 + nalen*Math.sin(degree - narc) - root_top,
						(x1 + b_x)/2 + nalen*Math.cos(degree + narc),
						(y1 + b_y)/2 + nalen*Math.sin(degree + narc) - root_top,
						(x1 + b_x)/2 + nalen*Math.cos(degree + narc)
							+ nalen*Math.cos(degree - narc),
						(y1 + b_y)/2 + nalen*Math.sin(degree + narc)
							+ nalen*Math.sin(degree - narc) - root_top);
					// 線分
					ctx.moveTo(x1, y1 - root_top);
					ctx.lineTo(b_x, b_y - root_top);
				}
				ctx.stroke();
			}
			else{
				ctx.lineWidth	= 1;
				ctx.strokeStyle	= "#000000";
				// 線分
				ctx.beginPath();
				ctx.moveTo(x1, y1 - root_top);
				if( count == 0 ){
					ctx.lineTo(x2, y2 - root_top);
					std_x = x1;
					std_y = y1;
				}
				else{
					b_x = (x2 - std_x)*(count / total);
					b_y = (y2 - std_y)*(count / total);

					ctx.lineTo(std_x + b_x, std_y - root_top + b_y);
				}
				ctx.stroke();
			}

			count++;
		}

		return true;
	}

	this.drawText		= function(top, left)
	{
		var		x	= this.left - left;
		var		y	= this.top - top;

		// ノードの背景色
		ctx.fillStyle = "#f2f2b0";
		ctx.fillRect(x, y, this.width, this.height)

		// ノードの枠
		ctx.strokeStyle = "#000000";
		ctx.lineWidth	= 1;
		ctx.beginPath();
		ctx.moveTo(x, y);
		ctx.lineTo(x + this.width, y);
		ctx.lineTo(x + this.width, y + this.height);
		ctx.lineTo(x, y + this.height);
		ctx.closePath();
		ctx.stroke();

		// ノード名
		if( this.op == "AND" ){
			ctx.clearRect(this.left - left, this.top - top, 13, this.height)

			ctx.strokeStyle = "#000000";
			ctx.lineWidth	= 1;
			ctx.beginPath();
			ctx.moveTo(x + 13, y);
			ctx.lineTo(x + 13, y + this.height);
			ctx.closePath();
			ctx.stroke();

			ctx.fillStyle = "#000000";
			ctx.fillText("∧ " + this.text, this.left - left, this.top - top + 15);
		}
		else if( this.op == "OR" ){
			ctx.clearRect(this.left - left, this.top - top, 13, this.height)

			ctx.strokeStyle = "#000000";
			ctx.lineWidth	= 1;
			ctx.beginPath();
			ctx.moveTo(x + 13, y);
			ctx.lineTo(x + 13, y + this.height);
			ctx.closePath();
			ctx.stroke();

			ctx.fillStyle = "#000000";
			ctx.fillText("∨ " + this.text, this.left - left, this.top - top + 15);
		}
		else{
			ctx.fillStyle = "#000000";
			ctx.fillText(" " + this.text, this.left - left, this.top - top + 15);
		}

		return true;
	}
}
