/** ready.js */

var		g_mmode	= "";
var		g_tmode	= "";
var		g_msgs	= {
	'NODE' : "ノードを配置する位置をクリックしてください",
	'ONE' : "ONE 制約を配置する位置をクリックしてください",
	'EXCL' : "EXCL 制約を配置する位置をクリックしてください",
	'INCL' : "INCL 制約を配置する位置をクリックしてください",
	'REQ' : "REQ 制約を配置する位置をクリックしてください",
	'MASK' : "MASK 制約を配置する位置をクリックしてください",
	'LINE' : "ラインを引いて、ノードや制約をつなげます。原因（あるいは始点）となるノード（あるいは制約）をクリックしてください"
};

var		root_top	= 0;
var		root_left	= 0;
var		dbg			= "";
var		logmsg		= "";
var		calcmsg		= "";

/* プロパティ */

/* 原因結果グラフのタイトル */
var		g_ceg_title		= "";
/* ライン描写の左側(始点)を示す番号 */
var		g_line_left		= -1;
/* ライン描写時のhoverポインタ */
var		g_hover_top		= -1;
var		g_hover_left	= -1;
/* ライン描写の右側(終点)を示す番号 */
var		g_line_right	= -1;
/* ライン描写の左側(始点)が制約か否か */
var		g_line_constr	= false;
/* ライン描写のNOTか否か */
var		g_line_not		= 0;

/* デシジョンテーブル表示状況 */
var		g_table_visible	= true;
/* カバレッジ表表示状況 */
var		g_coverage_visible	= true;
/* ドラッグ中の描画同期 */
var		g_dragging	=true;
/* ノードや制約にマウスをあてると関係式を表示 */
var		g_hover_visible	= true;
/* グラフデータのクリアの前に確認ダイアログを表示 */
var		g_confirm_before_clear	= true;


/* ラインを削除する状態かどうか */
var		g_cut			= false;
/* ラインを削除する始点 */
var		g_cut_start_x	= 0;
var		g_cut_start_y	= 0;

/* ズーム状態 */
var		g_zoom		= -1;

/* 線分描写キャンバス */
var		canvas	= null;
var		ctx		= null;

/* デシジョンテーブル、カバレッジ表のdraggableがあったかどうか */
var		ismove	= false;
/* 2010/07/19 置換オブジェクト(nodes配列と対応) */
var		subs	= new Array();
/* ノード要素 */
var		nodes	= new Array();
/* 制約要素 */
var		constrs	= new Array();
/* 論理式 */
var		logics	= new Array();
/* テスト条件 */
var		tests	= new Array();
/* テスト条件数 */
var		testnum	= 0;
/* 弱テスト条件状況 */
var		weaks	= new Array();
/* 各論理カバレッジの網羅状況 */
var		covs	= new Array();
/* 各論理カバレッジの網羅状況 */
var		vtestcov	= new Array();
/* 各論理式の適用順序 */
var		turns		= new Array();
/* 各論理式の非適用状況 */
var		unsuitables	= new Array();
/* テスト不可能性 */
var		infeasibles	= new Array();

/* エクスポートデータ */
var		expdata	= "";
var		exptable	= "";
var		expcoverage	= "";

/* 矢印の定義 */
var		arc		= (Math.PI * 5 / 6);
var		alen	= 10;

var		narc	= (Math.PI * 1 / 3);
var		nalen	= 30;

var		isIE	= false;

$(document).ready(function(){

	if( jQuery.support.boxModel == false ){
		dispMESSAGE("このブラウザでは一部のグラフが正しく表示できない可能性があります。", "#ff7f50");
		isIE = true;
	}

	jQuery(function($){
		$("#TEXT_NODE")
		.keydown(function(e){
			if( g_mmode == "NODE" ){
				if( e.keyCode == 13 ){
					var		no	= insertNODE(true);

					hideSUBS();
					dispOUTPUTS();
					return false;
				}
			}
		});
	});

	$("#MESSAGE")
	.click(
		function(e){
			hideELEMENT("MESSAGE");
		}
	);

	$("#TOOL_FILE,#TOOL_OPERATION,#TOOL_DISPLAY,#TOOL_OTHER,#TOOL_HELP")
	.hover(
		function(e){
			var	pos		= $(this).position();
			var	idname	= $(this).attr("id");

			$(this)
			.css("background-color", "#83ccd2")
			.css("color", "#333333");

			if( g_tmode != "" ){
				fadeInTOOLBAR(idname + "_LIST",
					(pos.top + $(this).height()),
					(pos.left));
			}
		},
		function(e){
			$(this)
			.css("background-color", "#165e83")
			.css("color", "#ffffff");
		}
	)
	.click(
		function(e){
			var	pos		= $(this).position();
			var	idname	= $(this).attr("id");

			if( g_tmode == "" ){
				fadeInTOOLBAR(idname + "_LIST",
					(pos.top + $(this).height()),
					(pos.left));
			}
			else{
				fadeInTOOLBAR("", 0, 0);
			}
			hideSUBS();
		}
	);

	$("#INPUTS")
	.mousedown(function(e){
		g_cut = true;
		g_cut_start_x = e.pageX;
		g_cut_start_y = e.pageY;
	})
	.mousemove(function(e){
		if( g_cut == true ){
			crossLine(e.pageY, e.pageX);
		}
	})
	.mouseup(function(e){
		g_cut = false;
	})
	.click(
		function(e){
			var	pos		= $(this).position();

			clickINPUTS(e.pageY - pos.top, e.pageX - pos.left);
		}
	)
    .contextMenu("INPUT_CANVAS_LIST",
        {
            bindings: {
            'CANVAS_UNDO': function(t) {
				alert("未実装です");
            },
            'CANVAS_ADJUST': function(t) {
				$("#IMPORT_CSV_GRAPH").val(getEXPORT_CSV_GRAPH());
				adjustGraph("グラフ表示の調整を行いました。");
            },
            'CANVAS_GRAPH_IMAGE': function(t) {
// 2010/02/13 画像化
				alert("未実装");
            },
            'CANVAS_CLEAR': function(t) {
				if( g_confirm_before_clear == true ){
					hideSUBS();
					$("#NO_CONFIRM_BEFORE_CLEAR")
						.attr("checked", !(g_confirm_before_clear));
					dispELEMENT("CLEAR_CONFIRM", 300, 300);
				}
				else{
					clearALL();
				}
            },
            'CANVAS_CONFIG': function(t) {
				pos = $("#INPUTS").position();
				fadeInTOOLBAR("", 0, 0);
				hideSUBS();
				getCONFIGS();
				dispELEMENT("CONFIGS", pos.top, pos.left);
            }
        }
    });

	$(".TOOL_LIST,.TOOL_LIST_TOP")
	.hover(
		function(e){
			$(this)
			.css("background-color", "#83ccd2")
			.css("color", "#333333");
		},
		function(e){
			$(this)
			.css("background-color", "#165e83")
			.css("color", "#ffffff");
		}
	)
	.click(
		function(e){
			clickTOOL_LIST($(this).attr("menu"));
		}
	);

	$(".INPUT_LIST,.INPUT_LIST_TOP")
	.hover(
		function(e){
			$(this).css("background-color", "#83ccd2");
		},
		function(e){
			$(this).css("background-color", "#bce2e8");
		}
	)
	.click(
		function(e){
			clickINPUT_LIST($(this).attr("menu"));
		}
	);

	$("#NODE,#ONE,#EXCL,#INCL,#REQ,#MASK,#LINE,#CUT")
	.hover(
		function(e){
			var	idname = $(this).attr("id");
			if( g_mmode != idname ){
				$(this).attr("src", "images/" + idname + "up.png");
			}
		},
		function(e){
			var	idname = $(this).attr("id");
			if( g_mmode != idname ){
				$(this).attr("src", "images/" + idname + ".png");
			}
		}
	)
	.click(
		function(e){
			clickMENUBAR($(this).attr("id"));
		}
	);

	$("#MANUAL_GUI,#MANUAL_NODE,#MANUAL_CONSTR,#MANUAL_LINE,#MANUAL_IMPORT,#MANUAL_EXPORT,#MANUAL_SAMPLES,#MANUAL_BROWSER,#MANUAL_HISTORY")
	.hover(
		function(e){
			$(this).css("background-color", "#008899");
			$(this).css("color", "#ffffff");
		},
		function(e){
			$(this).css("background-color", "#bce2e8");
			$(this).css("color", "#000000");
		}
	)
	.click(
		function(e){
			$("#MANUAL_INNER").attr("src", $(this).attr("page"));
		}
	);

	$(".NODE")
	.hover(
		function(e){
			overNODE($(this).attr("no"));
		},
		function(e){
			outNODE($(this).attr("no"));
		}
	)
	.click(
		function(e){
			clickNODE($(this).attr("no"));
		}
	)
	.draggable({
		cursor: 'move',
		drag: function(e,ui) {
			if( g_dragging == true ){
				var	no = $(this).attr("no");
				nodes[no].setTop($(this).position().top);
				nodes[no].setLeft($(this).position().left);

				// 2010/07/22 マウスアウトと同処理
				outNODE($(this).attr("no"));

				clearGRAPH();
				dispGRAPH();
			}
		},
		stop: function(e,ui) {
			var	same	= true;
			var	no = $(this).attr("no");
			nodes[no].setTop($(this).position().top);
			nodes[no].setLeft($(this).position().left);

			// 2010/07/22 マウスオーバーと同処理
			overNODE($(this).attr("no"));

			hideELEMENT("MESSAGE");
			clearGRAPH();
			// 2010/07/19 ノードの座標位置でnodesオブジェクトを並べ替え
			same = sortGRAPH();
			dispGRAPH();
			// 2010/07/19 並べ替えが生じたので再計算
			if( same == false ){
				dispOUTPUTS();
				dispMESSAGE("並べ替え・再計算を実行しました。", "#f8e58c");

			}
		}
	})
	.contextMenu("INPUT_NODE_LIST",
        {
            bindings: {
            'NODE_UPDATE': function(t) {
				var	no		= $("#INPUT_NODE_LIST").attr("no");
				var	pos		= $("#N" + no).position();
				var	height	= $("#N" + no).height();

				dispTEXT_UPDATE(no, pos.top + height, pos.left);
            },
            'AND_UPDATE': function(t) {
				var	no		= $("#INPUT_NODE_LIST").attr("no");
				var	pos		= $("#N" + no).position();
				var	height	= $("#N" + no).height();

				opNODE(no, "AND");
				clearGRAPH();
				sortGRAPH();
				dispGRAPH();
				dispOUTPUTS();
            },
            'OR_UPDATE': function(t) {
				var	no		= $("#INPUT_NODE_LIST").attr("no");
				var	pos		= $("#N" + no).position();
				var	height	= $("#N" + no).height();

				opNODE(no, "OR");
				clearGRAPH();
				sortGRAPH();
				dispGRAPH();
				dispOUTPUTS();
            },
            'OP_DELETE': function(t) {
				var	no		= $("#INPUT_NODE_LIST").attr("no");
				var	pos		= $("#N" + no).position();
				var	height	= $("#N" + no).height();

				opNODE(no, "");
				clearGRAPH();
				sortGRAPH();
				dispGRAPH();
				dispOUTPUTS();
            },
            'NODE_DELETE': function(t) {
				var	no		= $("#INPUT_NODE_LIST").attr("no");

				deleteNODE(no);
            },
			'ZOOM_OUT': function(t) {
				// 2010/08/20 カプセル化
				var	no		= $("#INPUT_NODE_LIST").attr("no");

				zoomOff(no);
				setNODE(no, nodes[no].getText(), nodes[no].getOp());
				g_zoom		= -1;
				if( zoomOut(no) == true ){
					$("#NOP" + no).text("＋");

					clearGRAPH();
					sortGRAPH();
					dispGRAPH();
					dispOUTPUTS();

					dispMESSAGE(nodes[no].getText() + " でズームアウトしました。", "#f8e58c");
				}
			},
			'PARTITIONING': function(t) {
				// 2010/08/20 カプセル化
				// 2011/01/23 分割に名称変更
				var	no		= $("#INPUT_NODE_LIST").attr("no");

				zoomOff(no);
				setNODE(no, nodes[no].getText(), nodes[no].getOp());
				g_zoom		= -1;
				if( zoomIn(no) == true ){
					g_zoom		= no;

					clearGRAPH();
					sortGRAPH();
					dispGRAPH();
					dispOUTPUTS();

					dispMESSAGE(nodes[no].getText() + " で分割しました。", "#f8e58c");
				}
			},
			'PARTITIONING_CANCEL': function(t) {
				// 2010/08/20 カプセル展開
				// 2011/01/23 分割解除に名称変更
				var	no		= $("#INPUT_NODE_LIST").attr("no");

				zoomOff(no);
				setNODE(no, nodes[no].getText(), nodes[no].getOp());
				g_zoom		= -1;

				clearGRAPH();
				sortGRAPH();
				dispGRAPH();
				dispOUTPUTS();

				dispMESSAGE(nodes[no].getText() + " の分割・ズームアウトを解除しました。", "#f8e58c");
			}
        }
    });

	$(".CONSTR")
	.hover(
		function(e){
			overCONSTR($(this).attr("no"));
		},
		function(e){
			outCONSTR($(this).attr("no"));
		}
	)
	.click(
		function(e){
			clickCONSTR($(this).attr("no"));
		}
	)
	.draggable({
		cursor: 'move',
		drag: function(e,ui) {
			if( g_dragging == true ){
				var	no = $(this).attr("no");
				constrs[no].setTop($(this).position().top);
				constrs[no].setLeft($(this).position().left);

				// 2010/07/22 マウスアウトと同処理
				outCONSTR($(this).attr("no"));

				clearGRAPH();
				dispGRAPH();
			}
		},
		stop: function(e,ui) {
			var	no = $(this).attr("no");
			constrs[no].setTop($(this).position().top);
			constrs[no].setLeft($(this).position().left);

			// 2010/07/22 マウスオーバーと同処理
			overCONSTR($(this).attr("no"));

			clearGRAPH();
			dispGRAPH();
		}
	})
    .contextMenu("INPUT_CONSTR_LIST",
        {
            bindings: {
            'CONSTR_ONE': function(t) {
				var	no = $("#INPUT_CONSTR_LIST").attr("no");

				updateCONSTR(no, "ONE");
            },
            'CONSTR_EXCL': function(t) {
				var	no = $("#INPUT_CONSTR_LIST").attr("no");

				updateCONSTR(no, "EXCL");
            },
            'CONSTR_INCL': function(t) {
				var	no = $("#INPUT_CONSTR_LIST").attr("no");

				updateCONSTR(no, "INCL");
            },
            'CONSTR_REQ': function(t) {
				var	no = $("#INPUT_CONSTR_LIST").attr("no");

				updateCONSTR(no, "REQ");
            },
            'CONSTR_MASK': function(t) {
				var	no = $("#INPUT_CONSTR_LIST").attr("no");

				updateCONSTR(no, "MASK");
            },
            'CONSTR_DELETE': function(t) {
				var	no = $("#INPUT_CONSTR_LIST").attr("no");

				deleteCONSTR(no);
            }
        }
    });

	$("#TABLE,#COVERAGE")
	.draggable({
		drag: function(e,ui) {
			ismove = true;
		},
		stop: function(e,ui) {
			;
		}
	})
	.dblclick(
		function(e){
			var	idname = $(this).attr("id");
			if( idname == "TABLE" ){
				g_table_visible = false;
			}
			else if( idname == "COVERAGE" ){
				g_coverage_visible = false;
			}
			hideELEMENT(idname);
			return true;
		}
	);

	$("#MANUALS,#DEBUGS")
	.draggable({
		drag: function(e,ui) {
			;
		},
		stop: function(e,ui) {
			;
		}
	})
	.dblclick(
		function(e){
			var	idname = $(this).attr("id");
			hideELEMENT(idname);
			return true;
		}
	);

	$("#CALCS,#OPERATIONS")
	.dblclick(
		function(e){
			var	idname = $(this).attr("id");
			hideELEMENT(idname);
			return true;
		}
	);

	$("#EDIT_DT")
	.click(
		function(e){
			clickEDIT_DT();
		}
	);

});

